reflex::Pattern::State Struct Reference

|  | reflex::Pattern::State Struct Reference updated Sat May 2 2020 by Robert van Engelen |

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Public Attributes | List of all members
reflex::Pattern::State Struct Reference

Finite state machine. More...

Inheritance diagram for reflex::Pattern::State:
[legend]
Collaboration diagram for reflex::Pattern::State:
[legend]

## Public Types
typedef std::map< Char, std::pair< Char, State * > > | Edges

## Public Member Functions
| State (const Positions &p)

## Public Attributes
State * | next
| points to sibling state allocated depth-first by subset construction More...
State * | left
| left pointer for O(log N) node insertion in the state graph More...
State * | right
| right pointer for O(log N) node insertion in the state graph More...
Edges | edges
| state transitions More...
Index | index
| index of this state More...
Accept | accept
| nonzero if final state, the index of an accepted/captured subpattern More...
Lookaheads | heads
| lookahead head set More...
Lookaheads | tails
| lookahead tail set More...
bool | redo
| true if this is an ignorable final state More...

## Detailed Description

Finite state machine.

## Member Typedef Documentation

typedef std::map<Char,std::pair<Char,State*> > reflex::Pattern::State::Edges

## Constructor & Destructor Documentation

reflex::Pattern::State::State | ( | const Positions & | p | ) |
| inline

## Member Data Documentation

Accept reflex::Pattern::State::accept

nonzero if final state, the index of an accepted/captured subpattern

Edges reflex::Pattern::State::edges

state transitions

Lookaheads reflex::Pattern::State::heads

lookahead head set

Index reflex::Pattern::State::index

index of this state

State* reflex::Pattern::State::left

left pointer for O(log N) node insertion in the state graph

State* reflex::Pattern::State::next

points to sibling state allocated depth-first by subset construction

bool reflex::Pattern::State::redo

true if this is an ignorable final state

State* reflex::Pattern::State::right

right pointer for O(log N) node insertion in the state graph

Lookaheads reflex::Pattern::State::tails

lookahead tail set

The documentation for this struct was generated from the following file:

- pattern.h